Package net.sf.saxon.type

## Class ErrorType

- java.lang.Object
- - net.sf.saxon.pattern.NodeTest
  - - net.sf.saxon.type.ErrorType

- All Implemented Interfaces:
    `java.util.function.Predicate<NodeInfo>`, `AtomicType`, `CastingTarget`, `ItemType`, `ItemType.WithSequenceTypeCache`, `PlainType`, `SchemaComponent`, `SchemaType`, `SimpleType`, `UnionType`

      public final class ErrorType
      extends NodeTest
      implements AtomicType, UnionType, PlainType

  This class has a singleton instance which represents the XML Schema 1.1 built-in type xs:error.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.type.ItemType

      `ItemType.WithSequenceTypeCache`

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.type.SchemaComponent

      `SchemaComponent.ValidationStatus`

  - ### Field Summary

    - ### Fields inherited from interface net.sf.saxon.type.SchemaComponent

      `COMPONENT_FUNCTION_TYPE`

    - ### Fields inherited from interface net.sf.saxon.type.SchemaType

      `DERIVATION_EXTENSION, DERIVATION_LIST, DERIVATION_RESTRICTION, DERIVATION_UNION, DERIVE_BY_SUBSTITUTION`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `allowsDerivation​(int derivation)` | Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property
    `void` | `analyzeContentExpression​(Expression expression, int kind)` | Analyze an expression to see whether the expression is capable of delivering a value of this type.
    `AtomicSequence` | `atomize​(NodeInfo node)` | Get the typed value of a node that is annotated with this schema type.
    `ValidationFailure` | `checkAgainstFacets​(AtomicValue value, ConversionRules rules)` | Validate an atomic value, which is known to be an instance of one of the member types of the union, against any facets (pattern facets or enumeration facets) defined at the level of the union itself.
    `void` | `checkTypeDerivationIsOK​(SchemaType type, int block)` | Check that this type is validly derived from a given type
    `boolean` | `containsListType()` | Ask whether the union contains a list type among its member types
    `java.util.Optional<java.lang.String>` | `explainMismatch​(Item item, TypeHierarchy th)` | Get extra diagnostic information about why a supplied item does not conform to this item type, if available.
    `AtomicType` | `getAtomizedItemType()` | Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)
    `SchemaType` | `getBaseType()` | Get the base type
    `int` | `getBlock()` | Returns the value of the 'block' attribute for this type, as a bit-signnificant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`
    `SchemaType` | `getBuiltInBaseType()` | Get the built-in ancestor of this type in the type hierarchy
    `Function` | `getComponentAsFunction()` | Get the schema component in the form of a function item.
    `double` | `getDefaultPriority()` | Determine the default priority to use if this node-test appears as a match pattern for a template with no explicit priority attribute.
    `int` | `getDerivationMethod()` | Gets the integer code of the derivation method used to derive this type from its parent.
    `java.lang.String` | `getDescription()` | Get a description of this type for use in diagnostics
    `java.lang.String` | `getDisplayName()` | Get the display name of the type: that is, a lexical QName with an arbitrary prefix
    `java.lang.String` | `getEQName()` | Get the name of this type as an EQName, that is, a string in the format Q{uri}local.
    `int` | `getFinalProhibitions()` | Get the types of derivation that are not permitted, by virtue of the "final" property.
    `int` | `getFingerprint()` | Get the fingerprint of the name of this type
    `static ErrorType` | `getInstance()` | Get the singular instance of this class
    `SchemaType` | `getKnownBaseType()` | Returns the base type that this type inherits from.
    `StructuredQName` | `getMatchingNodeName()` | Get the name of the nodes matched by this nodetest, if it matches a specific name.
    `java.lang.String` | `getName()` | Get the local name of this type
    `java.lang.Iterable<PlainType>` | `getPlainMemberTypes()` | Get the list of plain types that are subsumed by this type
    `AtomicType` | `getPrimitiveItemType()` | Get the primitive item type corresponding to this item type.
    `int` | `getPrimitiveType()` | Get the basic kind of object that this ItemType matches: for a NodeTest, this is the kind of node, or Type.Node if it matches different kinds of nodes.
    `int` | `getRedefinitionLevel()` | Get the redefinition level.
    `SequenceType` | `getResultTypeOfCast()` | Get the result type of a cast operation to this union type, as a sequence type.
    `StringConverter` | `getStringConverter​(ConversionRules rules)` | Get a StringConverter, an object which converts strings in the lexical space of this data type to instances (in the value space) of the data type.
    `StructuredQName` | `getStructuredQName()` | Get the name of this type as a StructuredQName, unless the type is anonymous, in which case return null
    `java.lang.String` | `getSystemId()` | Get the URI of the schema document containing the definition of this type
    `java.lang.String` | `getTargetNamespace()` | Get the target namespace of this type
    `AtomicSequence` | `getTypedValue​(java.lang.CharSequence value, NamespaceResolver resolver, ConversionRules rules)` | Get the typed value corresponding to a given string value, assuming it is valid against this type
    `StructuredQName` | `getTypeName()` | Get the name of the type as a StructuredQName
    `UType` | `getUType()` | Get the corresponding `UType`.
    `SchemaComponent.ValidationStatus` | `getValidationStatus()` | Get the validation status - always valid
    `int` | `getWhitespaceAction()` | Determine how values of this simple type are whitespace-normalized.
    `boolean` | `isAbstract()` | Determine whether the type is abstract, that is, whether it cannot have instances that are not also instances of some concrete subtype
    `boolean` | `isAnonymousType()` | Test whether this is an anonymous type
    `boolean` | `isAtomicType()` | Test whether this Simple Type is an atomic type
    `boolean` | `isAtomizable​(TypeHierarchy th)` | Ask whether values of this type are atomizable
    `boolean` | `isBuiltInType()` | Determine whether this is a built-in type or a user-defined type
    `boolean` | `isComplexType()` | Test whether this SchemaType is a complex type
    `boolean` | `isIdRefType()` | Ask whether this type is an IDREF or IDREFS type.
    `boolean` | `isIdType()` | Ask whether this type is an ID type.
    `boolean` | `isListType()` | Determine whether this is a list type
    `boolean` | `isNamespaceSensitive()` | Test whether this type represents namespace-sensitive content
    `boolean` | `isOrdered​(boolean optimistic)` | Determine whether the atomic type is ordered, that is, whether less-than and greater-than comparisons are permitted
    `boolean` | `isPlainType()` | Determine whether this item type is atomic (that is, whether it can ONLY match atomic values)
    `boolean` | `isPrimitiveType()` | Determine whether the atomic type is a primitive type.
    `boolean` | `isSameType​(SchemaType other)` | Test whether this is the same type as another type.
    `boolean` | `isSimpleType()` | Test whether this SchemaType is a simple type
    `boolean` | `isUnionType()` | Determin whether this is a union type
    `boolean` | `matches​(int nodeKind, NodeName name, SchemaType annotation)` | Test whether this node test is satisfied by a given node.
    `boolean` | `matches​(Item item, TypeHierarchy th)` | Test whether a given item conforms to this type
    `java.lang.CharSequence` | `postprocess​(java.lang.CharSequence input)` | Reverse any pre-lexical facets, other than whitespace.
    `java.lang.CharSequence` | `preprocess​(java.lang.CharSequence input)` | Apply any pre-lexical facets, other than whitespace.
    `java.lang.String` | `toExportString()` | Return a string representation of this ItemType suitable for use in stylesheet export files.
    `java.lang.String` | `toString()` |
    `ValidationFailure` | `validate​(AtomicValue primValue, java.lang.CharSequence lexicalValue, ConversionRules rules)` | Validate that a primitive atomic value is a valid instance of a type derived from the same primitive type.
    `ValidationFailure` | `validateContent​(java.lang.CharSequence value, NamespaceResolver nsResolver, ConversionRules rules)` | Check whether a given input string is valid according to this SimpleType

    - ### Methods inherited from class net.sf.saxon.pattern.NodeTest

      `copy, getBasicAlphaCode, getContentType, getGenre, getMatcher, getRequiredNodeNames, isNillable, one, oneOrMore, test, toShortString, zeroOrMore, zeroOrOne`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.type.AtomicType

      `getGenre`

    - ### Methods inherited from interface net.sf.saxon.type.ItemType

      `getBasicAlphaCode, getFullAlphaCode, getNormalizedDefaultPriority, isTrueItemType`

    - ### Methods inherited from interface java.util.function.Predicate

      `and, negate, or`

    - ### Methods inherited from interface net.sf.saxon.type.SchemaType

      `getNearestNamedType`

- - ### Method Detail

    - #### getUType

          public UType getUType()

      Get the corresponding `UType`. A UType is a union of primitive item types.
      Specified by:
        `getUType` in interface `ItemType`
      Returns:
        the smallest UType that subsumes this item type

    - #### getName

          public java.lang.String getName()

      Get the local name of this type
      Specified by:
        `getName` in interface `SchemaType`
      Returns:
        the local name of this type definition, if it has one. Return null in the case of an anonymous type.

    - #### getTargetNamespace

          public java.lang.String getTargetNamespace()

      Get the target namespace of this type
      Specified by:
        `getTargetNamespace` in interface `SchemaType`
      Returns:
        the target namespace of this type definition, if it has one. Return null in the case of an anonymous type, and in the case of a global type defined in a no-namespace schema.

    - #### getEQName

          public java.lang.String getEQName()

      Get the name of this type as an EQName, that is, a string in the format Q{uri}local.
      Specified by:
        `getEQName` in interface `SchemaType`
      Returns:
        an EQName identifying the type. In the case of an anonymous type, an internally-generated name is returned

    - #### containsListType

          public boolean containsListType()

      Description copied from interface: `UnionType`
      Ask whether the union contains a list type among its member types
      Specified by:
        `containsListType` in interface `UnionType`
      Returns:
        true of one of the member types is a list type

    - #### getPlainMemberTypes

          public java.lang.Iterable<PlainType> getPlainMemberTypes()

      Description copied from interface: `PlainType`
      Get the list of plain types that are subsumed by this type
      Specified by:
        `getPlainMemberTypes` in interface `PlainType`
      Specified by:
        `getPlainMemberTypes` in interface `UnionType`
      Returns:
        for an atomic type, the type itself; for a plain union type, the list of plain types in its transitive membership

    - #### isBuiltInType

          public boolean isBuiltInType()

      Determine whether this is a built-in type or a user-defined type
      Specified by:
        `isBuiltInType` in interface `AtomicType`
      Specified by:
        `isBuiltInType` in interface `SimpleType`
      Returns:
        true if this is a built-in type

    - #### getRedefinitionLevel

          public int getRedefinitionLevel()

      Get the redefinition level. This is zero for a component that has not been redefined; for a redefinition of a level-0 component, it is 1; for a redefinition of a level-N component, it is N+1. This concept is used to support the notion of "pervasive" redefinition: if a component is redefined at several levels, the top level wins, but it is an error to have two versions of the component at the same redefinition level.
      Specified by:
        `getRedefinitionLevel` in interface `SchemaComponent`
      Returns:
        the redefinition level

    - #### getSystemId

          public java.lang.String getSystemId()

      Get the URI of the schema document containing the definition of this type
      Specified by:
        `getSystemId` in interface `SchemaType`
      Returns:
        null for a built-in type

    - #### getInstance

          public static ErrorType getInstance()

      Get the singular instance of this class
      Returns:
        the singular object representing xs:anyType

    - #### getValidationStatus

          public SchemaComponent.ValidationStatus getValidationStatus()

      Get the validation status - always valid
      Specified by:
        `getValidationStatus` in interface `SchemaComponent`
      Returns:
        one of the values `SchemaComponent.ValidationStatus.UNVALIDATED`, `SchemaComponent.ValidationStatus.VALIDATING`, `SchemaComponent.ValidationStatus.VALIDATED`, `SchemaComponent.ValidationStatus.INVALID`, `SchemaComponent.ValidationStatus.INCOMPLETE`

    - #### getBaseType

          public SchemaType getBaseType()

      Get the base type
      Specified by:
        `getBaseType` in interface `SchemaType`
      Returns:
        AnyType

    - #### getKnownBaseType

          public SchemaType getKnownBaseType()

      Returns the base type that this type inherits from. This method can be used to get the base type of a type that is known to be valid.
      Returns:
        the base type.

    - #### isComplexType

          public boolean isComplexType()

      Test whether this SchemaType is a complex type
      Specified by:
        `isComplexType` in interface `SchemaType`
      Returns:
        true if this SchemaType is a complex type

    - #### isSimpleType

          public boolean isSimpleType()

      Test whether this SchemaType is a simple type
      Specified by:
        `isSimpleType` in interface `SchemaType`
      Returns:
        true if this SchemaType is a simple type

    - #### getFingerprint

          public int getFingerprint()

      Get the fingerprint of the name of this type
      Specified by:
        `getFingerprint` in interface `SchemaType`
      Overrides:
        `getFingerprint` in class `NodeTest`
      Returns:
        the fingerprint.

    - #### getMatchingNodeName

          public StructuredQName getMatchingNodeName()

      Get the name of the nodes matched by this nodetest, if it matches a specific name. Return null if the node test matches nodes of more than one name
      Overrides:
        `getMatchingNodeName` in class `NodeTest`

    - #### getTypeName

          public StructuredQName getTypeName()

      Get the name of the type as a StructuredQName
      Specified by:
        `getTypeName` in interface `AtomicType`
      Specified by:
        `getTypeName` in interface `PlainType`
      Specified by:
        `getTypeName` in interface `UnionType`
      Returns:
        a StructuredQName identifying the type. In the case of an anonymous type, an internally-generated name is returned

    - #### getDescription

          public java.lang.String getDescription()

      Get a description of this type for use in diagnostics
      Specified by:
        `getDescription` in interface `SchemaType`
      Specified by:
        `getDescription` in interface `UnionType`
      Returns:
        the string "xs:anyType"

    - #### getDisplayName

          public java.lang.String getDisplayName()

      Get the display name of the type: that is, a lexical QName with an arbitrary prefix
      Specified by:
        `getDisplayName` in interface `SchemaType`
      Returns:
        a lexical QName identifying the type

    - #### isSameType

          public boolean isSameType​(SchemaType other)

      Test whether this is the same type as another type. They are considered to be the same type if they are derived from the same type definition in the original XML representation (which can happen when there are multiple includes of the same file)
      Specified by:
        `isSameType` in interface `SchemaType`
      Parameters:
        `other` - the other type
      Returns:
        true if this is the same type as other

    - #### atomize

          public AtomicSequence atomize​(NodeInfo node)

      Get the typed value of a node that is annotated with this schema type.
      Specified by:
        `atomize` in interface `SchemaType`
      Parameters:
        `node` - the node whose typed value is required
      Returns:
        the typed value.
      Since:
        8.5

    - #### checkTypeDerivationIsOK

          public void checkTypeDerivationIsOK​(SchemaType type,
                                              int block)
                                       throws SchemaException

      Check that this type is validly derived from a given type
      Specified by:
        `checkTypeDerivationIsOK` in interface `SchemaType`
      Parameters:
        `type` - the type from which this type is derived
        `block` - the derivations that are blocked by the relevant element declaration
      Throws:
        `SchemaException` - if the derivation is not allowed

    - #### isAtomicType

          public boolean isAtomicType()

      Test whether this Simple Type is an atomic type
      Specified by:
        `isAtomicType` in interface `ItemType`
      Specified by:
        `isAtomicType` in interface `SchemaType`
      Specified by:
        `isAtomicType` in interface `SimpleType`
      Overrides:
        `isAtomicType` in class `NodeTest`
      Returns:
        false, this is not (necessarily) an atomic type

    - #### isIdType

          public boolean isIdType()

      Ask whether this type is an ID type. This is defined to be any simple type who typed value may contain atomic values of type xs:ID: that is, it includes types derived from ID by restriction, list, or union. Note that for a node to be treated as an ID, its typed value must be a *single* atomic value of type ID; the type of the node, however, can still allow a list.
      Specified by:
        `isIdType` in interface `AtomicType`
      Specified by:
        `isIdType` in interface `SchemaType`
      Returns:
        true if this type is an ID type

    - #### isIdRefType

          public boolean isIdRefType()

      Ask whether this type is an IDREF or IDREFS type. This is defined to be any simple type who typed value may contain atomic values of type xs:IDREF: that is, it includes types derived from IDREF or IDREFS by restriction, list, or union
      Specified by:
        `isIdRefType` in interface `AtomicType`
      Specified by:
        `isIdRefType` in interface `SchemaType`
      Returns:
        true if this type is an IDREF type

    - #### isAnonymousType

          public boolean isAnonymousType()

      Description copied from interface: `SchemaType`
      Test whether this is an anonymous type
      Specified by:
        `isAnonymousType` in interface `SchemaType`
      Returns:
        true if this SchemaType is an anonymous type

    - #### isListType

          public boolean isListType()

      Determine whether this is a list type
      Specified by:
        `isListType` in interface `SimpleType`
      Returns:
        false (it isn't a list type)

    - #### isUnionType

          public boolean isUnionType()

      Determin whether this is a union type
      Specified by:
        `isUnionType` in interface `SimpleType`
      Returns:
        true (this is a union type with no members)

    - #### getBuiltInBaseType

          public SchemaType getBuiltInBaseType()

      Get the built-in ancestor of this type in the type hierarchy
      Specified by:
        `getBuiltInBaseType` in interface `SimpleType`
      Returns:
        xs:anySimpleType

    - #### getTypedValue

          public AtomicSequence getTypedValue​(java.lang.CharSequence value,
                                              NamespaceResolver resolver,
                                              ConversionRules rules)
                                       throws ValidationException

      Get the typed value corresponding to a given string value, assuming it is valid against this type
      Specified by:
        `getTypedValue` in interface `SimpleType`
      Specified by:
        `getTypedValue` in interface `UnionType`
      Parameters:
        `value` - the string value
        `resolver` - a namespace resolver used to resolve any namespace prefixes appearing in the content of values. Can supply null, in which case any namespace-sensitive content will be rejected.
        `rules` - the conversion rules
      Returns:
        an iterator over the atomic sequence comprising the typed value. The objects returned by this SequenceIterator will all be of type `AtomicValue`
      Throws:
        `ValidationException` - if the supplied value is not in the lexical space of the data type (which is always true for this type)

    - #### getStringConverter

          public StringConverter getStringConverter​(ConversionRules rules)

      Get a StringConverter, an object which converts strings in the lexical space of this data type to instances (in the value space) of the data type.
      Specified by:
        `getStringConverter` in interface `AtomicType`
      Parameters:
        `rules` - the conversion rules to be used
      Returns:
        a StringConverter to do the conversion, or null if no built-in converter is available.

    - #### validateContent

          public ValidationFailure validateContent​(java.lang.CharSequence value,
                                                   NamespaceResolver nsResolver,
                                                   ConversionRules rules)

      Check whether a given input string is valid according to this SimpleType
      Specified by:
        `validateContent` in interface `SimpleType`
      Parameters:
        `value` - the input string to be checked
        `nsResolver` - a namespace resolver used to resolve namespace prefixes if the type is namespace sensitive. The value supplied may be null; in this case any namespace-sensitive content will throw an UnsupportedOperationException.
        `rules` - the conversion rules
      Returns:
        null if validation succeeds (which it never does for this implementation)
      Throws:
        `java.lang.UnsupportedOperationException` - if the type is namespace-sensitive and no namespace resolver is supplied

    - #### isNamespaceSensitive

          public boolean isNamespaceSensitive()

      Test whether this type represents namespace-sensitive content
      Specified by:
        `isNamespaceSensitive` in interface `PlainType`
      Specified by:
        `isNamespaceSensitive` in interface `SimpleType`
      Returns:
        false

    - #### getBlock

          public int getBlock()

      Returns the value of the 'block' attribute for this type, as a bit-signnificant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`
      Specified by:
        `getBlock` in interface `SchemaType`
      Returns:
        the value of the 'block' attribute for this type

    - #### getDerivationMethod

          public int getDerivationMethod()

      Gets the integer code of the derivation method used to derive this type from its parent. Returns zero for primitive types.
      Specified by:
        `getDerivationMethod` in interface `SchemaType`
      Returns:
        a numeric code representing the derivation method, for example `SchemaType.DERIVATION_RESTRICTION`

    - #### allowsDerivation

          public boolean allowsDerivation​(int derivation)

      Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property
      Specified by:
        `allowsDerivation` in interface `SchemaType`
      Parameters:
        `derivation` - the kind of derivation, for example `SchemaType.DERIVATION_LIST`
      Returns:
        true if this kind of derivation is allowed

    - #### getFinalProhibitions

          public int getFinalProhibitions()

      Get the types of derivation that are not permitted, by virtue of the "final" property.
      Specified by:
        `getFinalProhibitions` in interface `SchemaType`
      Returns:
        the types of derivation that are not permitted, as a bit-significant integer containing bits such as `SchemaType.DERIVATION_EXTENSION`

    - #### getWhitespaceAction

          public int getWhitespaceAction()

      Determine how values of this simple type are whitespace-normalized.
      Specified by:
        `getWhitespaceAction` in interface `SimpleType`
      Returns:
        one of `Whitespace.PRESERVE`, `Whitespace.COLLAPSE`, `Whitespace.REPLACE`.

    - #### analyzeContentExpression

          public void analyzeContentExpression​(Expression expression,
                                               int kind)
                                        throws XPathException

      Analyze an expression to see whether the expression is capable of delivering a value of this type.
      Specified by:
        `analyzeContentExpression` in interface `SchemaType`
      Parameters:
        `expression` - the expression that delivers the content
        `kind` - the node kind whose content is being delivered: `Type.ELEMENT`, `Type.ATTRIBUTE`, or `Type.DOCUMENT`
      Throws:
        `XPathException` - if the expression will never deliver a value of the correct type

    - #### preprocess

          public java.lang.CharSequence preprocess​(java.lang.CharSequence input)

      Apply any pre-lexical facets, other than whitespace. At the moment the only such facet is saxon:preprocess
      Specified by:
        `preprocess` in interface `SimpleType`
      Parameters:
        `input` - the value to be preprocessed
      Returns:
        the value after preprocessing

    - #### postprocess

          public java.lang.CharSequence postprocess​(java.lang.CharSequence input)

      Reverse any pre-lexical facets, other than whitespace. At the moment the only such facet is saxon:preprocess. This is called when converting a value of this type to a string
      Specified by:
        `postprocess` in interface `SimpleType`
      Parameters:
        `input` - the value to be postprocessed: this is the "ordinary" result of converting the value to a string
      Returns:
        the value after postprocessing

    - #### isPlainType

          public boolean isPlainType()

      Description copied from class: `NodeTest`
      Determine whether this item type is atomic (that is, whether it can ONLY match atomic values)
      Specified by:
        `isPlainType` in interface `ItemType`
      Overrides:
        `isPlainType` in class `NodeTest`
      Returns:
        false: this is not ANY_ATOMIC_TYPE or a subtype thereof

    - #### matches

          public boolean matches​(Item item,
                                 TypeHierarchy th)

      Description copied from interface: `ItemType`
      Test whether a given item conforms to this type
      Specified by:
        `matches` in interface `ItemType`
      Specified by:
        `matches` in interface `PlainType`
      Overrides:
        `matches` in class `NodeTest`
      Parameters:
        `item` - The item to be tested
        `th` - The type hierarchy cache. Currently used only when matching function items.
      Returns:
        true if the item is an instance of this type; false otherwise

    - #### matches

          public boolean matches​(int nodeKind,
                                 NodeName name,
                                 SchemaType annotation)

      Description copied from class: `NodeTest`
      Test whether this node test is satisfied by a given node. This method is only fully supported for a subset of NodeTests, because it doesn't provide all the information needed to evaluate all node tests. In particular (a) it can't be used to evaluate a node test of the form element(N,T) or schema-element(E) where it is necessary to know whether the node is nilled, and (b) it can't be used to evaluate a node test of the form document-node(element(X)). This in practice means that it is used (a) to evaluate the simple node tests found in the XPath 1.0 subset used in XML Schema, and (b) to evaluate node tests where the node kind is known to be an attribute.
      Specified by:
        `matches` in class `NodeTest`
      Parameters:
        `nodeKind` - The kind of node to be matched
        `name` - identifies the expanded name of the node to be matched. The value should be null for a node with no name.
        `annotation` - The actual content type of the node. Null means no constraint.
      Returns:
        true if the node matches this node test

    - #### getPrimitiveItemType

          public AtomicType getPrimitiveItemType()

      Description copied from class: `NodeTest`
      Get the primitive item type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.
      Specified by:
        `getPrimitiveItemType` in interface `ItemType`
      Specified by:
        `getPrimitiveItemType` in interface `PlainType`
      Overrides:
        `getPrimitiveItemType` in class `NodeTest`
      Returns:
        the corresponding primitive type

    - #### getPrimitiveType

          public int getPrimitiveType()

      Description copied from class: `NodeTest`
      Get the basic kind of object that this ItemType matches: for a NodeTest, this is the kind of node, or Type.Node if it matches different kinds of nodes.
      Specified by:
        `getPrimitiveType` in interface `ItemType`
      Overrides:
        `getPrimitiveType` in class `NodeTest`
      Returns:
        the node kind matched by this node test

    - #### getDefaultPriority

          public double getDefaultPriority()

      Description copied from class: `NodeTest`
      Determine the default priority to use if this node-test appears as a match pattern for a template with no explicit priority attribute.
      Specified by:
        `getDefaultPriority` in interface `AtomicType`
      Specified by:
        `getDefaultPriority` in interface `ItemType`
      Specified by:
        `getDefaultPriority` in class `NodeTest`
      Returns:
        the default priority for the pattern

    - #### getAtomizedItemType

          public AtomicType getAtomizedItemType()

      Description copied from class: `NodeTest`
      Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)
      Specified by:
        `getAtomizedItemType` in interface `ItemType`
      Overrides:
        `getAtomizedItemType` in class `NodeTest`
      Returns:
        the best available item type of the atomic values that will be produced when an item of this type is atomized, or null if it is known that atomization will throw an error.

    - #### isAtomizable

          public boolean isAtomizable​(TypeHierarchy th)

      Description copied from class: `NodeTest`
      Ask whether values of this type are atomizable
      Specified by:
        `isAtomizable` in interface `ItemType`
      Overrides:
        `isAtomizable` in class `NodeTest`
      Parameters:
        `th` - The type hierarchy cache
      Returns:
        true unless it is known that these items will be elements with element-only content, in which case return false

    - #### getResultTypeOfCast

          public SequenceType getResultTypeOfCast()

      Description copied from interface: `UnionType`
      Get the result type of a cast operation to this union type, as a sequence type.
      Specified by:
        `getResultTypeOfCast` in interface `UnionType`
      Returns:
        the result type of casting, as precisely as possible. For example, if all the member types of the union are derived from the same primitive type, this will return that primitive type.

    - #### toExportString

          public java.lang.String toExportString()

      Return a string representation of this ItemType suitable for use in stylesheet export files. This differs from the result of toString() in that it will not contain any references to anonymous types. Note that it may also use the Saxon extended syntax for union types and tuple types. The default implementation returns the result of calling `toString()`.
      Specified by:
        `toExportString` in interface `ItemType`
      Returns:
        the string representation as an instance of the XPath SequenceType construct

    - #### toString

          public java.lang.String toString()

      Specified by:
        `toString` in interface `ItemType`
      Overrides:
        `toString` in class `java.lang.Object`

    - #### validate

          public ValidationFailure validate​(AtomicValue primValue,
                                            java.lang.CharSequence lexicalValue,
                                            ConversionRules rules)

      Validate that a primitive atomic value is a valid instance of a type derived from the same primitive type.
      Specified by:
        `validate` in interface `AtomicType`
      Parameters:
        `primValue` - the value in the value space of the primitive type.
        `lexicalValue` - the value in the lexical space. If null, the string value of primValue is used. This value is checked against the pattern facet (if any)
        `rules` - the conversion rules
      Returns:
        null if the value is valid; otherwise, a ValidationFailure object indicating the nature of the error.
      Throws:
        `java.lang.UnsupportedOperationException` - in the case of an external object type

    - #### isOrdered

          public boolean isOrdered​(boolean optimistic)

      Determine whether the atomic type is ordered, that is, whether less-than and greater-than comparisons are permitted
      Specified by:
        `isOrdered` in interface `AtomicType`
      Parameters:
        `optimistic` - if true, the function takes an optimistic view, returning true if ordering comparisons are available for some subtype. This mainly affects xs:duration, where the function returns true if optimistic is true, false if it is false.
      Returns:
        true if ordering operations are permitted

    - #### isAbstract

          public boolean isAbstract()

      Determine whether the type is abstract, that is, whether it cannot have instances that are not also instances of some concrete subtype
      Specified by:
        `isAbstract` in interface `AtomicType`
      Returns:
        true if the type is abstract

    - #### isPrimitiveType

          public boolean isPrimitiveType()

      Determine whether the atomic type is a primitive type. The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration; xs:untypedAtomic; and all supertypes of these (xs:anyAtomicType, xs:numeric, ...)
      Specified by:
        `isPrimitiveType` in interface `AtomicType`
      Returns:
        true if the type is considered primitive under the above rules

    - #### getStructuredQName

          public StructuredQName getStructuredQName()

      Get the name of this type as a StructuredQName, unless the type is anonymous, in which case return null
      Specified by:
        `getStructuredQName` in interface `SchemaType`
      Specified by:
        `getStructuredQName` in interface `UnionType`
      Returns:
        the name of the atomic type, or null if the type is anonymous.

    - #### checkAgainstFacets

          public ValidationFailure checkAgainstFacets​(AtomicValue value,
                                                      ConversionRules rules)

      Validate an atomic value, which is known to be an instance of one of the member types of the union, against any facets (pattern facets or enumeration facets) defined at the level of the union itself.
      Specified by:
        `checkAgainstFacets` in interface `UnionType`
      Parameters:
        `value` - the Atomic Value to be checked. This must be an instance of a member type of the union
        `rules` - the ConversionRules for the Configuration
      Returns:
        a ValidationFailure if the value is not valid; null if it is valid.

    - #### explainMismatch

          public java.util.Optional<java.lang.String> explainMismatch​(Item item,
                                                                      TypeHierarchy th)

      Get extra diagnostic information about why a supplied item does not conform to this item type, if available. If extra information is returned, it should be in the form of a complete sentence, minus the closing full stop. No information should be returned for obvious cases.
      Specified by:
        `explainMismatch` in interface `AtomicType`
      Specified by:
        `explainMismatch` in interface `ItemType`
      Specified by:
        `explainMismatch` in interface `UnionType`
      Overrides:
        `explainMismatch` in class `NodeTest`
      Parameters:
        `item` - the item that doesn't match this type
        `th` - the type hierarchy cache
      Returns:
        optionally, a message explaining why the item does not match the type

    - #### getComponentAsFunction

          public Function getComponentAsFunction()

      Get the schema component in the form of a function item. This allows schema information to be made visible to XSLT or XQuery code. The function makes available the contents of the schema component as defined in the XSD specification. The function takes a string as argument representing a property name, and returns the corresponding property of the schema component. There is also a property "class" which returns the kind of schema component, for example "Attribute Declaration".
      Specified by:
        `getComponentAsFunction` in interface `SchemaComponent`
      Returns:
        the schema component represented as a function from property names to property values.